# Completions

## Create chat completion

`$ openai chat:completions create`

**post** `/chat/completions`

**Starting a new project?** We recommend trying [Responses](https://platform.openai.com/docs/api-reference/responses)
to take advantage of the latest OpenAI platform features. Compare
[Chat Completions with Responses](https://platform.openai.com/docs/guides/responses-vs-chat-completions?api-mode=responses).

---

Creates a model response for the given chat conversation. Learn more in the
[text generation](https://platform.openai.com/docs/guides/text-generation), [vision](https://platform.openai.com/docs/guides/vision),
and [audio](https://platform.openai.com/docs/guides/audio) guides.

Parameter support can differ depending on the model used to generate the
response, particularly for newer reasoning models. Parameters that are only
supported for reasoning models are noted below. For the current state of
unsupported parameters in reasoning models,
[refer to the reasoning guide](https://platform.openai.com/docs/guides/reasoning).

Returns a chat completion object, or a streamed sequence of chat completion
chunk objects if the request is streamed.

### Parameters

- `--message: array of ChatCompletionMessageParam`

  A list of messages comprising the conversation so far. Depending on the
  [model](https://platform.openai.com/docs/models) you use, different message types (modalities) are
  supported, like [text](https://platform.openai.com/docs/guides/text-generation),
  [images](https://platform.openai.com/docs/guides/vision), and [audio](https://platform.openai.com/docs/guides/audio).

- `--model: string or ChatModel`

  Model ID used to generate the response, like `gpt-4o` or `o3`. OpenAI
  offers a wide range of models with different capabilities, performance
  characteristics, and price points. Refer to the [model guide](https://platform.openai.com/docs/models)
  to browse and compare available models.

- `--audio: optional object { format, voice }`

  Parameters for audio output. Required when audio output is requested with
  `modalities: ["audio"]`. [Learn more](https://platform.openai.com/docs/guides/audio).

- `--frequency-penalty: optional number`

  Number between -2.0 and 2.0. Positive values penalize new tokens based on
  their existing frequency in the text so far, decreasing the model's
  likelihood to repeat the same line verbatim.

- `--function-call: optional "none" or "auto" or ChatCompletionFunctionCallOption`

  Deprecated in favor of `tool_choice`.

  Controls which (if any) function is called by the model.

  `none` means the model will not call a function and instead generates a
  message.

  `auto` means the model can pick between generating a message or calling a
  function.

  Specifying a particular function via `{"name": "my_function"}` forces the
  model to call that function.

  `none` is the default when no functions are present. `auto` is the default
  if functions are present.

- `--function: optional array of object { name, description, parameters }`

  Deprecated in favor of `tools`.

  A list of functions the model may generate JSON inputs for.

- `--logit-bias: optional map[number]`

  Modify the likelihood of specified tokens appearing in the completion.

  Accepts a JSON object that maps tokens (specified by their token ID in the
  tokenizer) to an associated bias value from -100 to 100. Mathematically,
  the bias is added to the logits generated by the model prior to sampling.
  The exact effect will vary per model, but values between -1 and 1 should
  decrease or increase likelihood of selection; values like -100 or 100
  should result in a ban or exclusive selection of the relevant token.

- `--logprobs: optional boolean`

  Whether to return log probabilities of the output tokens or not. If true,
  returns the log probabilities of each output token returned in the
  `content` of `message`.

- `--max-completion-tokens: optional number`

  An upper bound for the number of tokens that can be generated for a completion, including visible output tokens and [reasoning tokens](https://platform.openai.com/docs/guides/reasoning).

- `--max-tokens: optional number`

  The maximum number of [tokens](/tokenizer) that can be generated in the
  chat completion. This value can be used to control
  [costs](https://openai.com/api/pricing/) for text generated via API.

  This value is now deprecated in favor of `max_completion_tokens`, and is
  not compatible with [o-series models](https://platform.openai.com/docs/guides/reasoning).

- `--metadata: optional map[string]`

  Set of 16 key-value pairs that can be attached to an object. This can be
  useful for storing additional information about the object in a structured
  format, and querying for objects via API or the dashboard.

  Keys are strings with a maximum length of 64 characters. Values are strings
  with a maximum length of 512 characters.

- `--modality: optional array of "text" or "audio"`

  Output types that you would like the model to generate.
  Most models are capable of generating text, which is the default:

  `["text"]`

  The `gpt-4o-audio-preview` model can also be used to
  [generate audio](https://platform.openai.com/docs/guides/audio). To request that this model generate
  both text and audio responses, you can use:

  `["text", "audio"]`

- `--n: optional number`

  How many chat completion choices to generate for each input message. Note that you will be charged based on the number of generated tokens across all of the choices. Keep `n` as `1` to minimize costs.

- `--parallel-tool-calls: optional boolean`

  Whether to enable [parallel function calling](https://platform.openai.com/docs/guides/function-calling#configuring-parallel-function-calling) during tool use.

- `--prediction: optional object { content, type }`

  Static predicted output content, such as the content of a text file that is
  being regenerated.

- `--presence-penalty: optional number`

  Number between -2.0 and 2.0. Positive values penalize new tokens based on
  whether they appear in the text so far, increasing the model's likelihood
  to talk about new topics.

- `--prompt-cache-key: optional string`

  Used by OpenAI to cache responses for similar requests to optimize your cache hit rates. Replaces the `user` field. [Learn more](https://platform.openai.com/docs/guides/prompt-caching).

- `--prompt-cache-retention: optional "in_memory" or "24h"`

  The retention policy for the prompt cache. Set to `24h` to enable extended prompt caching, which keeps cached prefixes active for longer, up to a maximum of 24 hours. [Learn more](https://platform.openai.com/docs/guides/prompt-caching#prompt-cache-retention).

- `--reasoning-effort: optional "none" or "minimal" or "low" or 3 more`

  Constrains effort on reasoning for
  [reasoning models](https://platform.openai.com/docs/guides/reasoning).
  Currently supported values are `none`, `minimal`, `low`, `medium`, `high`, and `xhigh`. Reducing
  reasoning effort can result in faster responses and fewer tokens used
  on reasoning in a response.

  - `gpt-5.1` defaults to `none`, which does not perform reasoning. The supported reasoning values for `gpt-5.1` are `none`, `low`, `medium`, and `high`. Tool calls are supported for all reasoning values in gpt-5.1.
  - All models before `gpt-5.1` default to `medium` reasoning effort, and do not support `none`.
  - The `gpt-5-pro` model defaults to (and only supports) `high` reasoning effort.
  - `xhigh` is supported for all models after `gpt-5.1-codex-max`.

- `--response-format: optional ResponseFormatText or ResponseFormatJSONSchema or ResponseFormatJSONObject`

  An object specifying the format that the model must output.

  Setting to `{ "type": "json_schema", "json_schema": {...} }` enables
  Structured Outputs which ensures the model will match your supplied JSON
  schema. Learn more in the [Structured Outputs
  guide](https://platform.openai.com/docs/guides/structured-outputs).

  Setting to `{ "type": "json_object" }` enables the older JSON mode, which
  ensures the message the model generates is valid JSON. Using `json_schema`
  is preferred for models that support it.

- `--safety-identifier: optional string`

  A stable identifier used to help detect users of your application that may be violating OpenAI's usage policies.
  The IDs should be a string that uniquely identifies each user, with a maximum length of 64 characters. We recommend hashing their username or email address, in order to avoid sending us any identifying information. [Learn more](https://platform.openai.com/docs/guides/safety-best-practices#safety-identifiers).

- `--seed: optional number`

  This feature is in Beta.
  If specified, our system will make a best effort to sample deterministically, such that repeated requests with the same `seed` and parameters should return the same result.
  Determinism is not guaranteed, and you should refer to the `system_fingerprint` response parameter to monitor changes in the backend.

- `--service-tier: optional "auto" or "default" or "flex" or 2 more`

  Specifies the processing type used for serving the request.

  - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
  - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
  - If set to '[flex](https://platform.openai.com/docs/guides/flex-processing)' or '[priority](https://openai.com/api-priority-processing/)', then the request will be processed with the corresponding service tier.
  - When not set, the default behavior is 'auto'.

  When the `service_tier` parameter is set, the response body will include the `service_tier` value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

- `--stop: optional string or array of string`

  Not supported with latest reasoning models `o3` and `o4-mini`.

  Up to 4 sequences where the API will stop generating further tokens. The
  returned text will not contain the stop sequence.

- `--store: optional boolean`

  Whether or not to store the output of this chat completion request for
  use in our [model distillation](https://platform.openai.com/docs/guides/distillation) or
  [evals](https://platform.openai.com/docs/guides/evals) products.

  Supports text and image inputs. Note: image inputs over 8MB will be dropped.

- `--stream-options: optional object { include_obfuscation, include_usage }`

  Options for streaming response. Only set this when you set `stream: true`.

- `--temperature: optional number`

  What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
  We generally recommend altering this or `top_p` but not both.

- `--tool-choice: optional "none" or "auto" or "required" or ChatCompletionAllowedToolChoice or ChatCompletionNamedToolChoice or ChatCompletionNamedToolChoiceCustom`

  Controls which (if any) tool is called by the model.
  `none` means the model will not call any tool and instead generates a message.
  `auto` means the model can pick between generating a message or calling one or more tools.
  `required` means the model must call one or more tools.
  Specifying a particular tool via `{"type": "function", "function": {"name": "my_function"}}` forces the model to call that tool.

  `none` is the default when no tools are present. `auto` is the default if tools are present.

- `--tool: optional array of ChatCompletionTool`

  A list of tools the model may call. You can provide either
  [custom tools](https://platform.openai.com/docs/guides/function-calling#custom-tools) or
  [function tools](https://platform.openai.com/docs/guides/function-calling).

- `--top-logprobs: optional number`

  An integer between 0 and 20 specifying the maximum number of most likely
  tokens to return at each token position, each with an associated log
  probability. In some cases, the number of returned tokens may be fewer than
  requested.
  `logprobs` must be set to `true` if this parameter is used.

- `--top-p: optional number`

  An alternative to sampling with temperature, called nucleus sampling,
  where the model considers the results of the tokens with top_p probability
  mass. So 0.1 means only the tokens comprising the top 10% probability mass
  are considered.

  We generally recommend altering this or `temperature` but not both.

- `--user: optional string`

  This field is being replaced by `safety_identifier` and `prompt_cache_key`. Use `prompt_cache_key` instead to maintain caching optimizations.
  A stable identifier for your end-users.
  Used to boost cache hit rates by better bucketing similar requests and  to help OpenAI detect and prevent abuse. [Learn more](https://platform.openai.com/docs/guides/safety-best-practices#safety-identifiers).

- `--verbosity: optional "low" or "medium" or "high"`

  Constrains the verbosity of the model's response. Lower values will result in
  more concise responses, while higher values will result in more verbose responses.
  Currently supported values are `low`, `medium`, and `high`.

- `--web-search-options: optional object { search_context_size, user_location }`

  This tool searches the web for relevant results to use in a response.
  Learn more about the [web search tool](https://platform.openai.com/docs/guides/tools-web-search?api-mode=chat).

### Returns

- `chat_completion: object { id, choices, created, 5 more }`

  Represents a chat completion response returned by model, based on the provided input.

  - `id: string`

    A unique identifier for the chat completion.

  - `choices: array of object { finish_reason, index, logprobs, message }`

    A list of chat completion choices. Can be more than one if `n` is greater than 1.

    - `finish_reason: "stop" or "length" or "tool_calls" or 2 more`

      The reason the model stopped generating tokens. This will be `stop` if the model hit a natural stop point or a provided stop sequence,
      `length` if the maximum number of tokens specified in the request was reached,
      `content_filter` if content was omitted due to a flag from our content filters,
      `tool_calls` if the model called a tool, or `function_call` (deprecated) if the model called a function.

      - `"stop"`

      - `"length"`

      - `"tool_calls"`

      - `"content_filter"`

      - `"function_call"`

    - `index: number`

      The index of the choice in the list of choices.

    - `logprobs: object { content, refusal }`

      Log probability information for the choice.

      - `content: array of ChatCompletionTokenLogprob`

        A list of message content tokens with log probability information.

        - `token: string`

          The token.

        - `bytes: array of number`

          A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

        - `logprob: number`

          The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

        - `top_logprobs: array of object { token, bytes, logprob }`

          List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

          - `token: string`

            The token.

          - `bytes: array of number`

            A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

          - `logprob: number`

            The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

      - `refusal: array of ChatCompletionTokenLogprob`

        A list of message refusal tokens with log probability information.

        - `token: string`

          The token.

        - `bytes: array of number`

          A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

        - `logprob: number`

          The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

        - `top_logprobs: array of object { token, bytes, logprob }`

          List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

    - `message: object { content, refusal, role, 4 more }`

      A chat completion message generated by the model.

      - `content: string`

        The contents of the message.

      - `refusal: string`

        The refusal message generated by the model.

      - `role: "assistant"`

        The role of the author of this message.

      - `annotations: optional array of object { type, url_citation }`

        Annotations for the message, when applicable, as when using the
        [web search tool](https://platform.openai.com/docs/guides/tools-web-search?api-mode=chat).

        - `type: "url_citation"`

          The type of the URL citation. Always `url_citation`.

        - `url_citation: object { end_index, start_index, title, url }`

          A URL citation when using web search.

          - `end_index: number`

            The index of the last character of the URL citation in the message.

          - `start_index: number`

            The index of the first character of the URL citation in the message.

          - `title: string`

            The title of the web resource.

          - `url: string`

            The URL of the web resource.

      - `audio: optional object { id, data, expires_at, transcript }`

        If the audio output modality is requested, this object contains data
        about the audio response from the model. [Learn more](https://platform.openai.com/docs/guides/audio).

        - `id: string`

          Unique identifier for this audio response.

        - `data: string`

          Base64 encoded audio bytes generated by the model, in the format
          specified in the request.

        - `expires_at: number`

          The Unix timestamp (in seconds) for when this audio response will
          no longer be accessible on the server for use in multi-turn
          conversations.

        - `transcript: string`

          Transcript of the audio generated by the model.

      - `function_call: optional object { arguments, name }`

        Deprecated and replaced by `tool_calls`. The name and arguments of a function that should be called, as generated by the model.

        - `arguments: string`

          The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

        - `name: string`

          The name of the function to call.

      - `tool_calls: optional array of ChatCompletionMessageToolCall`

        The tool calls generated by the model, such as function calls.

        - `chat_completion_message_function_tool_call: object { id, function, type }`

          A call to a function tool created by the model.

          - `id: string`

            The ID of the tool call.

          - `function: object { arguments, name }`

            The function that the model called.

            - `arguments: string`

              The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

            - `name: string`

              The name of the function to call.

          - `type: "function"`

            The type of the tool. Currently, only `function` is supported.

        - `chat_completion_message_custom_tool_call: object { id, custom, type }`

          A call to a custom tool created by the model.

          - `id: string`

            The ID of the tool call.

          - `custom: object { input, name }`

            The custom tool that the model called.

            - `input: string`

              The input for the custom tool call generated by the model.

            - `name: string`

              The name of the custom tool to call.

          - `type: "custom"`

            The type of the tool. Always `custom`.

  - `created: number`

    The Unix timestamp (in seconds) of when the chat completion was created.

  - `model: string`

    The model used for the chat completion.

  - `object: "chat.completion"`

    The object type, which is always `chat.completion`.

  - `service_tier: optional "auto" or "default" or "flex" or 2 more`

    Specifies the processing type used for serving the request.

    - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
    - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
    - If set to '[flex](https://platform.openai.com/docs/guides/flex-processing)' or '[priority](https://openai.com/api-priority-processing/)', then the request will be processed with the corresponding service tier.
    - When not set, the default behavior is 'auto'.

    When the `service_tier` parameter is set, the response body will include the `service_tier` value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

    - `"auto"`

    - `"default"`

    - `"flex"`

    - `"scale"`

    - `"priority"`

  - `system_fingerprint: optional string`

    This fingerprint represents the backend configuration that the model runs with.

    Can be used in conjunction with the `seed` request parameter to understand when backend changes have been made that might impact determinism.

  - `usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }`

    Usage statistics for the completion request.

    - `completion_tokens: number`

      Number of tokens in the generated completion.

    - `prompt_tokens: number`

      Number of tokens in the prompt.

    - `total_tokens: number`

      Total number of tokens used in the request (prompt + completion).

    - `completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }`

      Breakdown of tokens used in a completion.

      - `accepted_prediction_tokens: optional number`

        When using Predicted Outputs, the number of tokens in the
        prediction that appeared in the completion.

      - `audio_tokens: optional number`

        Audio input tokens generated by the model.

      - `reasoning_tokens: optional number`

        Tokens generated by the model for reasoning.

      - `rejected_prediction_tokens: optional number`

        When using Predicted Outputs, the number of tokens in the
        prediction that did not appear in the completion. However, like
        reasoning tokens, these tokens are still counted in the total
        completion tokens for purposes of billing, output, and context window
        limits.

    - `prompt_tokens_details: optional object { audio_tokens, cached_tokens }`

      Breakdown of tokens used in the prompt.

      - `audio_tokens: optional number`

        Audio input tokens present in the prompt.

      - `cached_tokens: optional number`

        Cached tokens present in the prompt.

### Example

```cli
openai chat:completions create \
  --api-key 'My API Key' \
  --message '{content: string, role: developer}' \
  --model gpt-5.4
```

#### Response

```json
{
  "id": "id",
  "choices": [
    {
      "finish_reason": "stop",
      "index": 0,
      "logprobs": {
        "content": [
          {
            "token": "token",
            "bytes": [
              0
            ],
            "logprob": 0,
            "top_logprobs": [
              {
                "token": "token",
                "bytes": [
                  0
                ],
                "logprob": 0
              }
            ]
          }
        ],
        "refusal": [
          {
            "token": "token",
            "bytes": [
              0
            ],
            "logprob": 0,
            "top_logprobs": [
              {
                "token": "token",
                "bytes": [
                  0
                ],
                "logprob": 0
              }
            ]
          }
        ]
      },
      "message": {
        "content": "content",
        "refusal": "refusal",
        "role": "assistant",
        "annotations": [
          {
            "type": "url_citation",
            "url_citation": {
              "end_index": 0,
              "start_index": 0,
              "title": "title",
              "url": "https://example.com"
            }
          }
        ],
        "audio": {
          "id": "id",
          "data": "data",
          "expires_at": 0,
          "transcript": "transcript"
        },
        "function_call": {
          "arguments": "arguments",
          "name": "name"
        },
        "tool_calls": [
          {
            "id": "id",
            "function": {
              "arguments": "arguments",
              "name": "name"
            },
            "type": "function"
          }
        ]
      }
    }
  ],
  "created": 0,
  "model": "model",
  "object": "chat.completion",
  "service_tier": "auto",
  "system_fingerprint": "system_fingerprint",
  "usage": {
    "completion_tokens": 0,
    "prompt_tokens": 0,
    "total_tokens": 0,
    "completion_tokens_details": {
      "accepted_prediction_tokens": 0,
      "audio_tokens": 0,
      "reasoning_tokens": 0,
      "rejected_prediction_tokens": 0
    },
    "prompt_tokens_details": {
      "audio_tokens": 0,
      "cached_tokens": 0
    }
  }
}
```

## List Chat Completions

`$ openai chat:completions list`

**get** `/chat/completions`

List stored Chat Completions. Only Chat Completions that have been stored
with the `store` parameter set to `true` will be returned.

### Parameters

- `--after: optional string`

  Identifier for the last chat completion from the previous pagination request.

- `--limit: optional number`

  Number of Chat Completions to retrieve.

- `--metadata: optional map[string]`

  A list of metadata keys to filter the Chat Completions by. Example:

  `metadata[key1]=value1&metadata[key2]=value2`

- `--model: optional string`

  The model used to generate the Chat Completions.

- `--order: optional "asc" or "desc"`

  Sort order for Chat Completions by timestamp. Use `asc` for ascending order or `desc` for descending order. Defaults to `asc`.

### Returns

- `ChatCompletionList: object { data, first_id, has_more, 2 more }`

  An object representing a list of Chat Completions.

  - `data: array of ChatCompletion`

    An array of chat completion objects.

    - `id: string`

      A unique identifier for the chat completion.

    - `choices: array of object { finish_reason, index, logprobs, message }`

      A list of chat completion choices. Can be more than one if `n` is greater than 1.

      - `finish_reason: "stop" or "length" or "tool_calls" or 2 more`

        The reason the model stopped generating tokens. This will be `stop` if the model hit a natural stop point or a provided stop sequence,
        `length` if the maximum number of tokens specified in the request was reached,
        `content_filter` if content was omitted due to a flag from our content filters,
        `tool_calls` if the model called a tool, or `function_call` (deprecated) if the model called a function.

        - `"stop"`

        - `"length"`

        - `"tool_calls"`

        - `"content_filter"`

        - `"function_call"`

      - `index: number`

        The index of the choice in the list of choices.

      - `logprobs: object { content, refusal }`

        Log probability information for the choice.

        - `content: array of ChatCompletionTokenLogprob`

          A list of message content tokens with log probability information.

          - `token: string`

            The token.

          - `bytes: array of number`

            A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

          - `logprob: number`

            The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

          - `top_logprobs: array of object { token, bytes, logprob }`

            List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

            - `token: string`

              The token.

            - `bytes: array of number`

              A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

            - `logprob: number`

              The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

        - `refusal: array of ChatCompletionTokenLogprob`

          A list of message refusal tokens with log probability information.

          - `token: string`

            The token.

          - `bytes: array of number`

            A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

          - `logprob: number`

            The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

          - `top_logprobs: array of object { token, bytes, logprob }`

            List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

      - `message: object { content, refusal, role, 4 more }`

        A chat completion message generated by the model.

        - `content: string`

          The contents of the message.

        - `refusal: string`

          The refusal message generated by the model.

        - `role: "assistant"`

          The role of the author of this message.

        - `annotations: optional array of object { type, url_citation }`

          Annotations for the message, when applicable, as when using the
          [web search tool](https://platform.openai.com/docs/guides/tools-web-search?api-mode=chat).

          - `type: "url_citation"`

            The type of the URL citation. Always `url_citation`.

          - `url_citation: object { end_index, start_index, title, url }`

            A URL citation when using web search.

            - `end_index: number`

              The index of the last character of the URL citation in the message.

            - `start_index: number`

              The index of the first character of the URL citation in the message.

            - `title: string`

              The title of the web resource.

            - `url: string`

              The URL of the web resource.

        - `audio: optional object { id, data, expires_at, transcript }`

          If the audio output modality is requested, this object contains data
          about the audio response from the model. [Learn more](https://platform.openai.com/docs/guides/audio).

          - `id: string`

            Unique identifier for this audio response.

          - `data: string`

            Base64 encoded audio bytes generated by the model, in the format
            specified in the request.

          - `expires_at: number`

            The Unix timestamp (in seconds) for when this audio response will
            no longer be accessible on the server for use in multi-turn
            conversations.

          - `transcript: string`

            Transcript of the audio generated by the model.

        - `function_call: optional object { arguments, name }`

          Deprecated and replaced by `tool_calls`. The name and arguments of a function that should be called, as generated by the model.

          - `arguments: string`

            The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

          - `name: string`

            The name of the function to call.

        - `tool_calls: optional array of ChatCompletionMessageToolCall`

          The tool calls generated by the model, such as function calls.

          - `chat_completion_message_function_tool_call: object { id, function, type }`

            A call to a function tool created by the model.

            - `id: string`

              The ID of the tool call.

            - `function: object { arguments, name }`

              The function that the model called.

              - `arguments: string`

                The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

              - `name: string`

                The name of the function to call.

            - `type: "function"`

              The type of the tool. Currently, only `function` is supported.

          - `chat_completion_message_custom_tool_call: object { id, custom, type }`

            A call to a custom tool created by the model.

            - `id: string`

              The ID of the tool call.

            - `custom: object { input, name }`

              The custom tool that the model called.

              - `input: string`

                The input for the custom tool call generated by the model.

              - `name: string`

                The name of the custom tool to call.

            - `type: "custom"`

              The type of the tool. Always `custom`.

    - `created: number`

      The Unix timestamp (in seconds) of when the chat completion was created.

    - `model: string`

      The model used for the chat completion.

    - `object: "chat.completion"`

      The object type, which is always `chat.completion`.

    - `service_tier: optional "auto" or "default" or "flex" or 2 more`

      Specifies the processing type used for serving the request.

      - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
      - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
      - If set to '[flex](https://platform.openai.com/docs/guides/flex-processing)' or '[priority](https://openai.com/api-priority-processing/)', then the request will be processed with the corresponding service tier.
      - When not set, the default behavior is 'auto'.

      When the `service_tier` parameter is set, the response body will include the `service_tier` value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

      - `"auto"`

      - `"default"`

      - `"flex"`

      - `"scale"`

      - `"priority"`

    - `system_fingerprint: optional string`

      This fingerprint represents the backend configuration that the model runs with.

      Can be used in conjunction with the `seed` request parameter to understand when backend changes have been made that might impact determinism.

    - `usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }`

      Usage statistics for the completion request.

      - `completion_tokens: number`

        Number of tokens in the generated completion.

      - `prompt_tokens: number`

        Number of tokens in the prompt.

      - `total_tokens: number`

        Total number of tokens used in the request (prompt + completion).

      - `completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }`

        Breakdown of tokens used in a completion.

        - `accepted_prediction_tokens: optional number`

          When using Predicted Outputs, the number of tokens in the
          prediction that appeared in the completion.

        - `audio_tokens: optional number`

          Audio input tokens generated by the model.

        - `reasoning_tokens: optional number`

          Tokens generated by the model for reasoning.

        - `rejected_prediction_tokens: optional number`

          When using Predicted Outputs, the number of tokens in the
          prediction that did not appear in the completion. However, like
          reasoning tokens, these tokens are still counted in the total
          completion tokens for purposes of billing, output, and context window
          limits.

      - `prompt_tokens_details: optional object { audio_tokens, cached_tokens }`

        Breakdown of tokens used in the prompt.

        - `audio_tokens: optional number`

          Audio input tokens present in the prompt.

        - `cached_tokens: optional number`

          Cached tokens present in the prompt.

  - `first_id: string`

    The identifier of the first chat completion in the data array.

  - `has_more: boolean`

    Indicates whether there are more Chat Completions available.

  - `last_id: string`

    The identifier of the last chat completion in the data array.

  - `object: "list"`

    The type of this object. It is always set to "list".

### Example

```cli
openai chat:completions list \
  --api-key 'My API Key'
```

#### Response

```json
{
  "data": [
    {
      "id": "id",
      "choices": [
        {
          "finish_reason": "stop",
          "index": 0,
          "logprobs": {
            "content": [
              {
                "token": "token",
                "bytes": [
                  0
                ],
                "logprob": 0,
                "top_logprobs": [
                  {
                    "token": "token",
                    "bytes": [
                      0
                    ],
                    "logprob": 0
                  }
                ]
              }
            ],
            "refusal": [
              {
                "token": "token",
                "bytes": [
                  0
                ],
                "logprob": 0,
                "top_logprobs": [
                  {
                    "token": "token",
                    "bytes": [
                      0
                    ],
                    "logprob": 0
                  }
                ]
              }
            ]
          },
          "message": {
            "content": "content",
            "refusal": "refusal",
            "role": "assistant",
            "annotations": [
              {
                "type": "url_citation",
                "url_citation": {
                  "end_index": 0,
                  "start_index": 0,
                  "title": "title",
                  "url": "https://example.com"
                }
              }
            ],
            "audio": {
              "id": "id",
              "data": "data",
              "expires_at": 0,
              "transcript": "transcript"
            },
            "function_call": {
              "arguments": "arguments",
              "name": "name"
            },
            "tool_calls": [
              {
                "id": "id",
                "function": {
                  "arguments": "arguments",
                  "name": "name"
                },
                "type": "function"
              }
            ]
          }
        }
      ],
      "created": 0,
      "model": "model",
      "object": "chat.completion",
      "service_tier": "auto",
      "system_fingerprint": "system_fingerprint",
      "usage": {
        "completion_tokens": 0,
        "prompt_tokens": 0,
        "total_tokens": 0,
        "completion_tokens_details": {
          "accepted_prediction_tokens": 0,
          "audio_tokens": 0,
          "reasoning_tokens": 0,
          "rejected_prediction_tokens": 0
        },
        "prompt_tokens_details": {
          "audio_tokens": 0,
          "cached_tokens": 0
        }
      }
    }
  ],
  "first_id": "first_id",
  "has_more": true,
  "last_id": "last_id",
  "object": "list"
}
```

## Get chat completion

`$ openai chat:completions retrieve`

**get** `/chat/completions/{completion_id}`

Get a stored chat completion. Only Chat Completions that have been created
with the `store` parameter set to `true` will be returned.

### Parameters

- `--completion-id: string`

  The ID of the chat completion to retrieve.

### Returns

- `chat_completion: object { id, choices, created, 5 more }`

  Represents a chat completion response returned by model, based on the provided input.

  - `id: string`

    A unique identifier for the chat completion.

  - `choices: array of object { finish_reason, index, logprobs, message }`

    A list of chat completion choices. Can be more than one if `n` is greater than 1.

    - `finish_reason: "stop" or "length" or "tool_calls" or 2 more`

      The reason the model stopped generating tokens. This will be `stop` if the model hit a natural stop point or a provided stop sequence,
      `length` if the maximum number of tokens specified in the request was reached,
      `content_filter` if content was omitted due to a flag from our content filters,
      `tool_calls` if the model called a tool, or `function_call` (deprecated) if the model called a function.

      - `"stop"`

      - `"length"`

      - `"tool_calls"`

      - `"content_filter"`

      - `"function_call"`

    - `index: number`

      The index of the choice in the list of choices.

    - `logprobs: object { content, refusal }`

      Log probability information for the choice.

      - `content: array of ChatCompletionTokenLogprob`

        A list of message content tokens with log probability information.

        - `token: string`

          The token.

        - `bytes: array of number`

          A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

        - `logprob: number`

          The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

        - `top_logprobs: array of object { token, bytes, logprob }`

          List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

          - `token: string`

            The token.

          - `bytes: array of number`

            A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

          - `logprob: number`

            The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

      - `refusal: array of ChatCompletionTokenLogprob`

        A list of message refusal tokens with log probability information.

        - `token: string`

          The token.

        - `bytes: array of number`

          A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

        - `logprob: number`

          The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

        - `top_logprobs: array of object { token, bytes, logprob }`

          List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

    - `message: object { content, refusal, role, 4 more }`

      A chat completion message generated by the model.

      - `content: string`

        The contents of the message.

      - `refusal: string`

        The refusal message generated by the model.

      - `role: "assistant"`

        The role of the author of this message.

      - `annotations: optional array of object { type, url_citation }`

        Annotations for the message, when applicable, as when using the
        [web search tool](https://platform.openai.com/docs/guides/tools-web-search?api-mode=chat).

        - `type: "url_citation"`

          The type of the URL citation. Always `url_citation`.

        - `url_citation: object { end_index, start_index, title, url }`

          A URL citation when using web search.

          - `end_index: number`

            The index of the last character of the URL citation in the message.

          - `start_index: number`

            The index of the first character of the URL citation in the message.

          - `title: string`

            The title of the web resource.

          - `url: string`

            The URL of the web resource.

      - `audio: optional object { id, data, expires_at, transcript }`

        If the audio output modality is requested, this object contains data
        about the audio response from the model. [Learn more](https://platform.openai.com/docs/guides/audio).

        - `id: string`

          Unique identifier for this audio response.

        - `data: string`

          Base64 encoded audio bytes generated by the model, in the format
          specified in the request.

        - `expires_at: number`

          The Unix timestamp (in seconds) for when this audio response will
          no longer be accessible on the server for use in multi-turn
          conversations.

        - `transcript: string`

          Transcript of the audio generated by the model.

      - `function_call: optional object { arguments, name }`

        Deprecated and replaced by `tool_calls`. The name and arguments of a function that should be called, as generated by the model.

        - `arguments: string`

          The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

        - `name: string`

          The name of the function to call.

      - `tool_calls: optional array of ChatCompletionMessageToolCall`

        The tool calls generated by the model, such as function calls.

        - `chat_completion_message_function_tool_call: object { id, function, type }`

          A call to a function tool created by the model.

          - `id: string`

            The ID of the tool call.

          - `function: object { arguments, name }`

            The function that the model called.

            - `arguments: string`

              The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

            - `name: string`

              The name of the function to call.

          - `type: "function"`

            The type of the tool. Currently, only `function` is supported.

        - `chat_completion_message_custom_tool_call: object { id, custom, type }`

          A call to a custom tool created by the model.

          - `id: string`

            The ID of the tool call.

          - `custom: object { input, name }`

            The custom tool that the model called.

            - `input: string`

              The input for the custom tool call generated by the model.

            - `name: string`

              The name of the custom tool to call.

          - `type: "custom"`

            The type of the tool. Always `custom`.

  - `created: number`

    The Unix timestamp (in seconds) of when the chat completion was created.

  - `model: string`

    The model used for the chat completion.

  - `object: "chat.completion"`

    The object type, which is always `chat.completion`.

  - `service_tier: optional "auto" or "default" or "flex" or 2 more`

    Specifies the processing type used for serving the request.

    - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
    - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
    - If set to '[flex](https://platform.openai.com/docs/guides/flex-processing)' or '[priority](https://openai.com/api-priority-processing/)', then the request will be processed with the corresponding service tier.
    - When not set, the default behavior is 'auto'.

    When the `service_tier` parameter is set, the response body will include the `service_tier` value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

    - `"auto"`

    - `"default"`

    - `"flex"`

    - `"scale"`

    - `"priority"`

  - `system_fingerprint: optional string`

    This fingerprint represents the backend configuration that the model runs with.

    Can be used in conjunction with the `seed` request parameter to understand when backend changes have been made that might impact determinism.

  - `usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }`

    Usage statistics for the completion request.

    - `completion_tokens: number`

      Number of tokens in the generated completion.

    - `prompt_tokens: number`

      Number of tokens in the prompt.

    - `total_tokens: number`

      Total number of tokens used in the request (prompt + completion).

    - `completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }`

      Breakdown of tokens used in a completion.

      - `accepted_prediction_tokens: optional number`

        When using Predicted Outputs, the number of tokens in the
        prediction that appeared in the completion.

      - `audio_tokens: optional number`

        Audio input tokens generated by the model.

      - `reasoning_tokens: optional number`

        Tokens generated by the model for reasoning.

      - `rejected_prediction_tokens: optional number`

        When using Predicted Outputs, the number of tokens in the
        prediction that did not appear in the completion. However, like
        reasoning tokens, these tokens are still counted in the total
        completion tokens for purposes of billing, output, and context window
        limits.

    - `prompt_tokens_details: optional object { audio_tokens, cached_tokens }`

      Breakdown of tokens used in the prompt.

      - `audio_tokens: optional number`

        Audio input tokens present in the prompt.

      - `cached_tokens: optional number`

        Cached tokens present in the prompt.

### Example

```cli
openai chat:completions retrieve \
  --api-key 'My API Key' \
  --completion-id completion_id
```

#### Response

```json
{
  "id": "id",
  "choices": [
    {
      "finish_reason": "stop",
      "index": 0,
      "logprobs": {
        "content": [
          {
            "token": "token",
            "bytes": [
              0
            ],
            "logprob": 0,
            "top_logprobs": [
              {
                "token": "token",
                "bytes": [
                  0
                ],
                "logprob": 0
              }
            ]
          }
        ],
        "refusal": [
          {
            "token": "token",
            "bytes": [
              0
            ],
            "logprob": 0,
            "top_logprobs": [
              {
                "token": "token",
                "bytes": [
                  0
                ],
                "logprob": 0
              }
            ]
          }
        ]
      },
      "message": {
        "content": "content",
        "refusal": "refusal",
        "role": "assistant",
        "annotations": [
          {
            "type": "url_citation",
            "url_citation": {
              "end_index": 0,
              "start_index": 0,
              "title": "title",
              "url": "https://example.com"
            }
          }
        ],
        "audio": {
          "id": "id",
          "data": "data",
          "expires_at": 0,
          "transcript": "transcript"
        },
        "function_call": {
          "arguments": "arguments",
          "name": "name"
        },
        "tool_calls": [
          {
            "id": "id",
            "function": {
              "arguments": "arguments",
              "name": "name"
            },
            "type": "function"
          }
        ]
      }
    }
  ],
  "created": 0,
  "model": "model",
  "object": "chat.completion",
  "service_tier": "auto",
  "system_fingerprint": "system_fingerprint",
  "usage": {
    "completion_tokens": 0,
    "prompt_tokens": 0,
    "total_tokens": 0,
    "completion_tokens_details": {
      "accepted_prediction_tokens": 0,
      "audio_tokens": 0,
      "reasoning_tokens": 0,
      "rejected_prediction_tokens": 0
    },
    "prompt_tokens_details": {
      "audio_tokens": 0,
      "cached_tokens": 0
    }
  }
}
```

## Update chat completion

`$ openai chat:completions update`

**post** `/chat/completions/{completion_id}`

Modify a stored chat completion. Only Chat Completions that have been
created with the `store` parameter set to `true` can be modified. Currently,
the only supported modification is to update the `metadata` field.

### Parameters

- `--completion-id: string`

  The ID of the chat completion to update.

- `--metadata: map[string]`

  Set of 16 key-value pairs that can be attached to an object. This can be
  useful for storing additional information about the object in a structured
  format, and querying for objects via API or the dashboard.

  Keys are strings with a maximum length of 64 characters. Values are strings
  with a maximum length of 512 characters.

### Returns

- `chat_completion: object { id, choices, created, 5 more }`

  Represents a chat completion response returned by model, based on the provided input.

  - `id: string`

    A unique identifier for the chat completion.

  - `choices: array of object { finish_reason, index, logprobs, message }`

    A list of chat completion choices. Can be more than one if `n` is greater than 1.

    - `finish_reason: "stop" or "length" or "tool_calls" or 2 more`

      The reason the model stopped generating tokens. This will be `stop` if the model hit a natural stop point or a provided stop sequence,
      `length` if the maximum number of tokens specified in the request was reached,
      `content_filter` if content was omitted due to a flag from our content filters,
      `tool_calls` if the model called a tool, or `function_call` (deprecated) if the model called a function.

      - `"stop"`

      - `"length"`

      - `"tool_calls"`

      - `"content_filter"`

      - `"function_call"`

    - `index: number`

      The index of the choice in the list of choices.

    - `logprobs: object { content, refusal }`

      Log probability information for the choice.

      - `content: array of ChatCompletionTokenLogprob`

        A list of message content tokens with log probability information.

        - `token: string`

          The token.

        - `bytes: array of number`

          A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

        - `logprob: number`

          The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

        - `top_logprobs: array of object { token, bytes, logprob }`

          List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

          - `token: string`

            The token.

          - `bytes: array of number`

            A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

          - `logprob: number`

            The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

      - `refusal: array of ChatCompletionTokenLogprob`

        A list of message refusal tokens with log probability information.

        - `token: string`

          The token.

        - `bytes: array of number`

          A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

        - `logprob: number`

          The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

        - `top_logprobs: array of object { token, bytes, logprob }`

          List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

    - `message: object { content, refusal, role, 4 more }`

      A chat completion message generated by the model.

      - `content: string`

        The contents of the message.

      - `refusal: string`

        The refusal message generated by the model.

      - `role: "assistant"`

        The role of the author of this message.

      - `annotations: optional array of object { type, url_citation }`

        Annotations for the message, when applicable, as when using the
        [web search tool](https://platform.openai.com/docs/guides/tools-web-search?api-mode=chat).

        - `type: "url_citation"`

          The type of the URL citation. Always `url_citation`.

        - `url_citation: object { end_index, start_index, title, url }`

          A URL citation when using web search.

          - `end_index: number`

            The index of the last character of the URL citation in the message.

          - `start_index: number`

            The index of the first character of the URL citation in the message.

          - `title: string`

            The title of the web resource.

          - `url: string`

            The URL of the web resource.

      - `audio: optional object { id, data, expires_at, transcript }`

        If the audio output modality is requested, this object contains data
        about the audio response from the model. [Learn more](https://platform.openai.com/docs/guides/audio).

        - `id: string`

          Unique identifier for this audio response.

        - `data: string`

          Base64 encoded audio bytes generated by the model, in the format
          specified in the request.

        - `expires_at: number`

          The Unix timestamp (in seconds) for when this audio response will
          no longer be accessible on the server for use in multi-turn
          conversations.

        - `transcript: string`

          Transcript of the audio generated by the model.

      - `function_call: optional object { arguments, name }`

        Deprecated and replaced by `tool_calls`. The name and arguments of a function that should be called, as generated by the model.

        - `arguments: string`

          The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

        - `name: string`

          The name of the function to call.

      - `tool_calls: optional array of ChatCompletionMessageToolCall`

        The tool calls generated by the model, such as function calls.

        - `chat_completion_message_function_tool_call: object { id, function, type }`

          A call to a function tool created by the model.

          - `id: string`

            The ID of the tool call.

          - `function: object { arguments, name }`

            The function that the model called.

            - `arguments: string`

              The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

            - `name: string`

              The name of the function to call.

          - `type: "function"`

            The type of the tool. Currently, only `function` is supported.

        - `chat_completion_message_custom_tool_call: object { id, custom, type }`

          A call to a custom tool created by the model.

          - `id: string`

            The ID of the tool call.

          - `custom: object { input, name }`

            The custom tool that the model called.

            - `input: string`

              The input for the custom tool call generated by the model.

            - `name: string`

              The name of the custom tool to call.

          - `type: "custom"`

            The type of the tool. Always `custom`.

  - `created: number`

    The Unix timestamp (in seconds) of when the chat completion was created.

  - `model: string`

    The model used for the chat completion.

  - `object: "chat.completion"`

    The object type, which is always `chat.completion`.

  - `service_tier: optional "auto" or "default" or "flex" or 2 more`

    Specifies the processing type used for serving the request.

    - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
    - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
    - If set to '[flex](https://platform.openai.com/docs/guides/flex-processing)' or '[priority](https://openai.com/api-priority-processing/)', then the request will be processed with the corresponding service tier.
    - When not set, the default behavior is 'auto'.

    When the `service_tier` parameter is set, the response body will include the `service_tier` value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

    - `"auto"`

    - `"default"`

    - `"flex"`

    - `"scale"`

    - `"priority"`

  - `system_fingerprint: optional string`

    This fingerprint represents the backend configuration that the model runs with.

    Can be used in conjunction with the `seed` request parameter to understand when backend changes have been made that might impact determinism.

  - `usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }`

    Usage statistics for the completion request.

    - `completion_tokens: number`

      Number of tokens in the generated completion.

    - `prompt_tokens: number`

      Number of tokens in the prompt.

    - `total_tokens: number`

      Total number of tokens used in the request (prompt + completion).

    - `completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }`

      Breakdown of tokens used in a completion.

      - `accepted_prediction_tokens: optional number`

        When using Predicted Outputs, the number of tokens in the
        prediction that appeared in the completion.

      - `audio_tokens: optional number`

        Audio input tokens generated by the model.

      - `reasoning_tokens: optional number`

        Tokens generated by the model for reasoning.

      - `rejected_prediction_tokens: optional number`

        When using Predicted Outputs, the number of tokens in the
        prediction that did not appear in the completion. However, like
        reasoning tokens, these tokens are still counted in the total
        completion tokens for purposes of billing, output, and context window
        limits.

    - `prompt_tokens_details: optional object { audio_tokens, cached_tokens }`

      Breakdown of tokens used in the prompt.

      - `audio_tokens: optional number`

        Audio input tokens present in the prompt.

      - `cached_tokens: optional number`

        Cached tokens present in the prompt.

### Example

```cli
openai chat:completions update \
  --api-key 'My API Key' \
  --completion-id completion_id \
  --metadata '{foo: string}'
```

#### Response

```json
{
  "id": "id",
  "choices": [
    {
      "finish_reason": "stop",
      "index": 0,
      "logprobs": {
        "content": [
          {
            "token": "token",
            "bytes": [
              0
            ],
            "logprob": 0,
            "top_logprobs": [
              {
                "token": "token",
                "bytes": [
                  0
                ],
                "logprob": 0
              }
            ]
          }
        ],
        "refusal": [
          {
            "token": "token",
            "bytes": [
              0
            ],
            "logprob": 0,
            "top_logprobs": [
              {
                "token": "token",
                "bytes": [
                  0
                ],
                "logprob": 0
              }
            ]
          }
        ]
      },
      "message": {
        "content": "content",
        "refusal": "refusal",
        "role": "assistant",
        "annotations": [
          {
            "type": "url_citation",
            "url_citation": {
              "end_index": 0,
              "start_index": 0,
              "title": "title",
              "url": "https://example.com"
            }
          }
        ],
        "audio": {
          "id": "id",
          "data": "data",
          "expires_at": 0,
          "transcript": "transcript"
        },
        "function_call": {
          "arguments": "arguments",
          "name": "name"
        },
        "tool_calls": [
          {
            "id": "id",
            "function": {
              "arguments": "arguments",
              "name": "name"
            },
            "type": "function"
          }
        ]
      }
    }
  ],
  "created": 0,
  "model": "model",
  "object": "chat.completion",
  "service_tier": "auto",
  "system_fingerprint": "system_fingerprint",
  "usage": {
    "completion_tokens": 0,
    "prompt_tokens": 0,
    "total_tokens": 0,
    "completion_tokens_details": {
      "accepted_prediction_tokens": 0,
      "audio_tokens": 0,
      "reasoning_tokens": 0,
      "rejected_prediction_tokens": 0
    },
    "prompt_tokens_details": {
      "audio_tokens": 0,
      "cached_tokens": 0
    }
  }
}
```

## Delete chat completion

`$ openai chat:completions delete`

**delete** `/chat/completions/{completion_id}`

Delete a stored chat completion. Only Chat Completions that have been
created with the `store` parameter set to `true` can be deleted.

### Parameters

- `--completion-id: string`

  The ID of the chat completion to delete.

### Returns

- `chat_completion_deleted: object { id, deleted, object }`

  - `id: string`

    The ID of the chat completion that was deleted.

  - `deleted: boolean`

    Whether the chat completion was deleted.

  - `object: "chat.completion.deleted"`

    The type of object being deleted.

### Example

```cli
openai chat:completions delete \
  --api-key 'My API Key' \
  --completion-id completion_id
```

#### Response

```json
{
  "id": "id",
  "deleted": true,
  "object": "chat.completion.deleted"
}
```

## Domain Types

### Chat Completion

- `chat_completion: object { id, choices, created, 5 more }`

  Represents a chat completion response returned by model, based on the provided input.

  - `id: string`

    A unique identifier for the chat completion.

  - `choices: array of object { finish_reason, index, logprobs, message }`

    A list of chat completion choices. Can be more than one if `n` is greater than 1.

    - `finish_reason: "stop" or "length" or "tool_calls" or 2 more`

      The reason the model stopped generating tokens. This will be `stop` if the model hit a natural stop point or a provided stop sequence,
      `length` if the maximum number of tokens specified in the request was reached,
      `content_filter` if content was omitted due to a flag from our content filters,
      `tool_calls` if the model called a tool, or `function_call` (deprecated) if the model called a function.

      - `"stop"`

      - `"length"`

      - `"tool_calls"`

      - `"content_filter"`

      - `"function_call"`

    - `index: number`

      The index of the choice in the list of choices.

    - `logprobs: object { content, refusal }`

      Log probability information for the choice.

      - `content: array of ChatCompletionTokenLogprob`

        A list of message content tokens with log probability information.

        - `token: string`

          The token.

        - `bytes: array of number`

          A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

        - `logprob: number`

          The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

        - `top_logprobs: array of object { token, bytes, logprob }`

          List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

          - `token: string`

            The token.

          - `bytes: array of number`

            A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

          - `logprob: number`

            The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

      - `refusal: array of ChatCompletionTokenLogprob`

        A list of message refusal tokens with log probability information.

        - `token: string`

          The token.

        - `bytes: array of number`

          A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

        - `logprob: number`

          The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

        - `top_logprobs: array of object { token, bytes, logprob }`

          List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

    - `message: object { content, refusal, role, 4 more }`

      A chat completion message generated by the model.

      - `content: string`

        The contents of the message.

      - `refusal: string`

        The refusal message generated by the model.

      - `role: "assistant"`

        The role of the author of this message.

      - `annotations: optional array of object { type, url_citation }`

        Annotations for the message, when applicable, as when using the
        [web search tool](https://platform.openai.com/docs/guides/tools-web-search?api-mode=chat).

        - `type: "url_citation"`

          The type of the URL citation. Always `url_citation`.

        - `url_citation: object { end_index, start_index, title, url }`

          A URL citation when using web search.

          - `end_index: number`

            The index of the last character of the URL citation in the message.

          - `start_index: number`

            The index of the first character of the URL citation in the message.

          - `title: string`

            The title of the web resource.

          - `url: string`

            The URL of the web resource.

      - `audio: optional object { id, data, expires_at, transcript }`

        If the audio output modality is requested, this object contains data
        about the audio response from the model. [Learn more](https://platform.openai.com/docs/guides/audio).

        - `id: string`

          Unique identifier for this audio response.

        - `data: string`

          Base64 encoded audio bytes generated by the model, in the format
          specified in the request.

        - `expires_at: number`

          The Unix timestamp (in seconds) for when this audio response will
          no longer be accessible on the server for use in multi-turn
          conversations.

        - `transcript: string`

          Transcript of the audio generated by the model.

      - `function_call: optional object { arguments, name }`

        Deprecated and replaced by `tool_calls`. The name and arguments of a function that should be called, as generated by the model.

        - `arguments: string`

          The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

        - `name: string`

          The name of the function to call.

      - `tool_calls: optional array of ChatCompletionMessageToolCall`

        The tool calls generated by the model, such as function calls.

        - `chat_completion_message_function_tool_call: object { id, function, type }`

          A call to a function tool created by the model.

          - `id: string`

            The ID of the tool call.

          - `function: object { arguments, name }`

            The function that the model called.

            - `arguments: string`

              The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

            - `name: string`

              The name of the function to call.

          - `type: "function"`

            The type of the tool. Currently, only `function` is supported.

        - `chat_completion_message_custom_tool_call: object { id, custom, type }`

          A call to a custom tool created by the model.

          - `id: string`

            The ID of the tool call.

          - `custom: object { input, name }`

            The custom tool that the model called.

            - `input: string`

              The input for the custom tool call generated by the model.

            - `name: string`

              The name of the custom tool to call.

          - `type: "custom"`

            The type of the tool. Always `custom`.

  - `created: number`

    The Unix timestamp (in seconds) of when the chat completion was created.

  - `model: string`

    The model used for the chat completion.

  - `object: "chat.completion"`

    The object type, which is always `chat.completion`.

  - `service_tier: optional "auto" or "default" or "flex" or 2 more`

    Specifies the processing type used for serving the request.

    - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
    - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
    - If set to '[flex](https://platform.openai.com/docs/guides/flex-processing)' or '[priority](https://openai.com/api-priority-processing/)', then the request will be processed with the corresponding service tier.
    - When not set, the default behavior is 'auto'.

    When the `service_tier` parameter is set, the response body will include the `service_tier` value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

    - `"auto"`

    - `"default"`

    - `"flex"`

    - `"scale"`

    - `"priority"`

  - `system_fingerprint: optional string`

    This fingerprint represents the backend configuration that the model runs with.

    Can be used in conjunction with the `seed` request parameter to understand when backend changes have been made that might impact determinism.

  - `usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }`

    Usage statistics for the completion request.

    - `completion_tokens: number`

      Number of tokens in the generated completion.

    - `prompt_tokens: number`

      Number of tokens in the prompt.

    - `total_tokens: number`

      Total number of tokens used in the request (prompt + completion).

    - `completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }`

      Breakdown of tokens used in a completion.

      - `accepted_prediction_tokens: optional number`

        When using Predicted Outputs, the number of tokens in the
        prediction that appeared in the completion.

      - `audio_tokens: optional number`

        Audio input tokens generated by the model.

      - `reasoning_tokens: optional number`

        Tokens generated by the model for reasoning.

      - `rejected_prediction_tokens: optional number`

        When using Predicted Outputs, the number of tokens in the
        prediction that did not appear in the completion. However, like
        reasoning tokens, these tokens are still counted in the total
        completion tokens for purposes of billing, output, and context window
        limits.

    - `prompt_tokens_details: optional object { audio_tokens, cached_tokens }`

      Breakdown of tokens used in the prompt.

      - `audio_tokens: optional number`

        Audio input tokens present in the prompt.

      - `cached_tokens: optional number`

        Cached tokens present in the prompt.

### Chat Completion Allowed Tool Choice

- `chat_completion_allowed_tool_choice: object { allowed_tools, type }`

  Constrains the tools available to the model to a pre-defined set.

  - `allowed_tools: object { mode, tools }`

    Constrains the tools available to the model to a pre-defined set.

    - `mode: "auto" or "required"`

      Constrains the tools available to the model to a pre-defined set.

      `auto` allows the model to pick from among the allowed tools and generate a
      message.

      `required` requires the model to call one or more of the allowed tools.

      - `"auto"`

      - `"required"`

    - `tools: array of map[unknown]`

      A list of tool definitions that the model should be allowed to call.

      For the Chat Completions API, the list of tool definitions might look like:

      ```json
      [
        { "type": "function", "function": { "name": "get_weather" } },
        { "type": "function", "function": { "name": "get_time" } }
      ]
      ```

  - `type: "allowed_tools"`

    Allowed tool configuration type. Always `allowed_tools`.

### Chat Completion Assistant Message Param

- `chat_completion_assistant_message_param: object { role, audio, content, 4 more }`

  Messages sent by the model in response to user messages.

  - `role: "assistant"`

    The role of the messages author, in this case `assistant`.

  - `audio: optional object { id }`

    Data about a previous audio response from the model.
    [Learn more](https://platform.openai.com/docs/guides/audio).

    - `id: string`

      Unique identifier for a previous audio response from the model.

  - `content: optional string or array of ChatCompletionContentPartText or ChatCompletionContentPartRefusal`

    The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified.

    - `Text content: string`

      The contents of the assistant message.

    - `Array of content parts: array of ChatCompletionContentPartText or ChatCompletionContentPartRefusal`

      An array of content parts with a defined type. Can be one or more of type `text`, or exactly one of type `refusal`.

      - `chat_completion_content_part_text: object { text, type }`

        Learn about [text inputs](https://platform.openai.com/docs/guides/text-generation).

        - `text: string`

          The text content.

        - `type: "text"`

          The type of the content part.

      - `chat_completion_content_part_refusal: object { refusal, type }`

        - `refusal: string`

          The refusal message generated by the model.

        - `type: "refusal"`

          The type of the content part.

  - `function_call: optional object { arguments, name }`

    Deprecated and replaced by `tool_calls`. The name and arguments of a function that should be called, as generated by the model.

    - `arguments: string`

      The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

    - `name: string`

      The name of the function to call.

  - `name: optional string`

    An optional name for the participant. Provides the model information to differentiate between participants of the same role.

  - `refusal: optional string`

    The refusal message by the assistant.

  - `tool_calls: optional array of ChatCompletionMessageToolCall`

    The tool calls generated by the model, such as function calls.

    - `chat_completion_message_function_tool_call: object { id, function, type }`

      A call to a function tool created by the model.

      - `id: string`

        The ID of the tool call.

      - `function: object { arguments, name }`

        The function that the model called.

        - `arguments: string`

          The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

        - `name: string`

          The name of the function to call.

      - `type: "function"`

        The type of the tool. Currently, only `function` is supported.

    - `chat_completion_message_custom_tool_call: object { id, custom, type }`

      A call to a custom tool created by the model.

      - `id: string`

        The ID of the tool call.

      - `custom: object { input, name }`

        The custom tool that the model called.

        - `input: string`

          The input for the custom tool call generated by the model.

        - `name: string`

          The name of the custom tool to call.

      - `type: "custom"`

        The type of the tool. Always `custom`.

### Chat Completion Audio

- `chat_completion_audio: object { id, data, expires_at, transcript }`

  If the audio output modality is requested, this object contains data
  about the audio response from the model. [Learn more](https://platform.openai.com/docs/guides/audio).

  - `id: string`

    Unique identifier for this audio response.

  - `data: string`

    Base64 encoded audio bytes generated by the model, in the format
    specified in the request.

  - `expires_at: number`

    The Unix timestamp (in seconds) for when this audio response will
    no longer be accessible on the server for use in multi-turn
    conversations.

  - `transcript: string`

    Transcript of the audio generated by the model.

### Chat Completion Audio Param

- `chat_completion_audio_param: object { format, voice }`

  Parameters for audio output. Required when audio output is requested with
  `modalities: ["audio"]`. [Learn more](https://platform.openai.com/docs/guides/audio).

  - `format: "wav" or "aac" or "mp3" or 3 more`

    Specifies the output audio format. Must be one of `wav`, `mp3`, `flac`,
    `opus`, or `pcm16`.

    - `"wav"`

    - `"aac"`

    - `"mp3"`

    - `"flac"`

    - `"opus"`

    - `"pcm16"`

  - `voice: string or "alloy" or "ash" or "ballad" or 7 more or object { id }`

    The voice the model uses to respond. Supported built-in voices are
    `alloy`, `ash`, `ballad`, `coral`, `echo`, `fable`, `nova`, `onyx`,
    `sage`, `shimmer`, `marin`, and `cedar`. You may also provide a
    custom voice object with an `id`, for example `{ "id": "voice_1234" }`.

    - `union_member_0: string`

    - `union_member_1: "alloy" or "ash" or "ballad" or 7 more`

      - `"alloy"`

      - `"ash"`

      - `"ballad"`

      - `"coral"`

      - `"echo"`

      - `"sage"`

      - `"shimmer"`

      - `"verse"`

      - `"marin"`

      - `"cedar"`

    - `id: object { id }`

      Custom voice reference.

      - `id: string`

        The custom voice ID, e.g. `voice_1234`.

### Chat Completion Chunk

- `chat_completion_chunk: object { id, choices, created, 5 more }`

  Represents a streamed chunk of a chat completion response returned
  by the model, based on the provided input.
  [Learn more](https://platform.openai.com/docs/guides/streaming-responses).

  - `id: string`

    A unique identifier for the chat completion. Each chunk has the same ID.

  - `choices: array of object { delta, finish_reason, index, logprobs }`

    A list of chat completion choices. Can contain more than one elements if `n` is greater than 1. Can also be empty for the
    last chunk if you set `stream_options: {"include_usage": true}`.

    - `delta: object { content, function_call, refusal, 2 more }`

      A chat completion delta generated by streamed model responses.

      - `content: optional string`

        The contents of the chunk message.

      - `function_call: optional object { arguments, name }`

        Deprecated and replaced by `tool_calls`. The name and arguments of a function that should be called, as generated by the model.

        - `arguments: optional string`

          The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

        - `name: optional string`

          The name of the function to call.

      - `refusal: optional string`

        The refusal message generated by the model.

      - `role: optional "developer" or "system" or "user" or 2 more`

        The role of the author of this message.

        - `"developer"`

        - `"system"`

        - `"user"`

        - `"assistant"`

        - `"tool"`

      - `tool_calls: optional array of object { index, id, function, type }`

        - `index: number`

        - `id: optional string`

          The ID of the tool call.

        - `function: optional object { arguments, name }`

          - `arguments: optional string`

            The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.

          - `name: optional string`

            The name of the function to call.

        - `type: optional "function"`

          The type of the tool. Currently, only `function` is supported.

          - `"function"`

    - `finish_reason: "stop" or "length" or "tool_calls" or 2 more`

      The reason the model stopped generating tokens. This will be `stop` if the model hit a natural stop point or a provided stop sequence,
      `length` if the maximum number of tokens specified in the request was reached,
      `content_filter` if content was omitted due to a flag from our content filters,
      `tool_calls` if the model called a tool, or `function_call` (deprecated) if the model called a function.

      - `"stop"`

      - `"length"`

      - `"tool_calls"`

      - `"content_filter"`

      - `"function_call"`

    - `index: number`

      The index of the choice in the list of choices.

    - `logprobs: optional object { content, refusal }`

      Log probability information for the choice.

      - `content: array of ChatCompletionTokenLogprob`

        A list of message content tokens with log probability information.

        - `token: string`

          The token.

        - `bytes: array of number`

          A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

        - `logprob: number`

          The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

        - `top_logprobs: array of object { token, bytes, logprob }`

          List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

          - `token: string`

            The token.

          - `bytes: array of number`

            A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

          - `logprob: number`

            The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

      - `refusal: array of ChatCompletionTokenLogprob`

        A list of message refusal tokens with log probability information.

        - `token: string`

          The token.

        - `bytes: array of number`

          A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be `null` if there is no bytes representation for the token.

        - `logprob: number`

          The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value `-9999.0` is used to signify that the token is very unlikely.

        - `top_logprobs: array of object { token, bytes, logprob }`

          List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested `top_logprobs`.

  - `created: number`

    The Unix timestamp (in seconds) of when the chat completion was created. Each chunk has the same timestamp.

  - `model: string`

    The model to generate the completion.

  - `object: "chat.completion.chunk"`

    The object type, which is always `chat.completion.chunk`.

  - `service_tier: optional "auto" or "default" or "flex" or 2 more`

    Specifies the processing type used for serving the request.

    - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
    - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
    - If set to '[flex](https://platform.openai.com/docs/guides/flex-processing)' or '[priority](https://openai.com/api-priority-processing/)', then the request will be processed with the corresponding service tier.
    - When not set, the default behavior is 'auto'.

    When the `service_tier` parameter is set, the response body will include the `service_tier` value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

    - `"auto"`

    - `"default"`

    - `"flex"`

    - `"scale"`

    - `"priority"`

  - `system_fingerprint: optional string`

    This fingerprint represents the backend configuration that the model runs with.
    Can be used in conjunction with the `seed` request parameter to understand when backend changes have been made that might impact determinism.

  - `usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }`

    An optional field that will only be present when you set
    `stream_options: {"include_usage": true}` in your request. When present, it
    contains a null value **except for the last chunk** which contains the
    token usage statistics for the entire request.

    **NOTE:** If the stream is interrupted or cancelled, you may not
    receive the final usage chunk which contains the total token usage for
    the request.

    - `completion_tokens: number`

      Number of tokens in the generated completion.

    - `prompt_tokens: number`

      Number of tokens in the prompt.

    - `total_tokens: number`

      Total number of tokens used in the request (prompt + completion).

    - `completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }`

      Breakdown of tokens used in a completion.

      - `accepted_prediction_tokens: optional number`

        When using Predicted Outputs, the number of tokens in the
        prediction that appeared in the completion.

      - `audio_tokens: optional number`

        Audio input tokens generated by the model.

      - `reasoning_tokens: optional number`

        Tokens generated by the model for reasoning.

      - `rejected_prediction_tokens: optional number`

        When using Predicted Outputs, the number of tokens in the
        prediction that did not appear in the completion. However, like
        reasoning tokens, these tokens are still counted in the total
        completion tokens for purposes of billing, output, and context window
        limits.

    - `prompt_tokens_details: optional object { audio_tokens, cached_tokens }`

      Breakdown of tokens used in the prompt.

      - `audio_tokens: optional number`

        Audio input tokens present in the prompt.

      - `cached_tokens: optional number`

        Cached tokens present in the prompt.

### Chat Completion Content Part

- `chat_completion_content_part: ChatCompletionContentPartText or ChatCompletionContentPartImage or ChatCompletionContentPartInputAudio or object { file, type }`

  Learn about [text inputs](https://platform.openai.com/docs/guides/text-generation).

  - `chat_completion_content_part_text: object { text, type }`

    Learn about [text inputs](https://platform.openai.com/docs/guides/text-generation).

    - `text: string`

      The text content.

    - `type: "text"`

      The type of the content part.

  - `chat_completion_content_part_image: object { image_url, type }`

    Learn about [image inputs](https://platform.openai.com/docs/guides/vision).

    - `image_url: object { url, detail }`

      - `url: string`

        Either a URL of the image or the base64 encoded image data.

      - `detail: optional "auto" or "low" or "high"`

        Specifies the detail level of the image. Learn more in the [Vision guide](https://platform.openai.com/docs/guides/vision#low-or-high-fidelity-image-understanding).

        - `"auto"`

        - `"low"`

        - `"high"`

    - `type: "image_url"`

      The type of the content part.

  - `chat_completion_content_part_input_audio: object { input_audio, type }`

    Learn about [audio inputs](https://platform.openai.com/docs/guides/audio).

[...]
